variable string goal = None
variable string one = B
variable string two = P
variable string three = R
variable string four = W
	
variable int currentClicky = 1
	
function main()
{
	call UpdateColors
	while !(${goal.Equals[${one}]} && ${goal.Equals[${two}]} && ${goal.Equals[${three}]} && ${goal.Equals[${four}]})
	{
		
		call RotateOrbs
		
		wait 15
		call UpdateColors
		echo ${Time}: ${goal} ${one} ${two} ${three} ${four}
		
	}
}


function RotateOrbs()
{
	call GetMatchCount
	variable int matches = 0
	matches:Set[${Return}]
	echo Matches = ${matches}
	
	if ${one.Equals[${three}]}
	{
		if ${one.Equals[${goal}]}
		{
			currentClicky:Inc[1]
		}
		elseif ${matches} == 3
		{
			if ${two.Equals[${goal}]}
			{
				currentClicky:Set[4]
			}
			elseif ${four.Equals[${goal}]}
			{
				currentClicky:Set[2]
			}
		}
	}
	elseif ${two.Equals[${four}]}
	{
		if ${two.Equals[${goal}]}
		{
			currentClicky:Inc[1]
		}
		elseif ${matches} == 3
		{
			if ${one.Equals[${goal}]}
			{
				currentClicky:Set[3]
			}
			elseif ${three.Equals[${goal}]}
			{
				currentClicky:Set[1]
			}
		}
	}
	elseif ${one.Equals[${two}]} || ${two.Equals[${three}]} || ${three.Equals[${four}]} || ${four.Equals[${one}]}
	{
		currentClicky:Set[1]
		currentClicky:Inc[${Math.Rand[3]}]
		;currentClicky:Inc[1]
	}
	if ${currentClicky} == 5
	{
		currentClicky:Set[1]
	}
	echo Actor[Clicky ${currentClicky}]:DoubleClick
	face "${Actor[Clicky ${currentClicky}].Name}"
	Actor[Clicky ${currentClicky}]:DoubleClick
}
function GetMatchCount()
{
	variable int matches = 0
	
	if ${one.Equals[${two}]}
	{
		matches:Inc[1]
	}
	if ${two.Equals[${three}]}
	{
		matches:Inc[1]
	}
	if ${three.Equals[${four}]}
	{
		matches:Inc[1]
	}
	if ${four.Equals[${one}]}
	{
		matches:Inc[1]
	}
	if ${one.Equals[${three}]}
	{
		matches:Inc[1]
	}
	if ${two.Equals[${four}]}
	{
		matches:Inc[1]
	}
	
	return ${matches}
}
function UpdateColors()
{
	call getColor "${Actor[ Main].Name}"
	goal:Set[${Return}]
	call getColor "${Actor[ Clicky 1].Name}"
	one:Set[${Return}]
	call getColor "${Actor[ Clicky 2].Name}"
	two:Set[${Return}]
	call getColor "${Actor[ Clicky 3].Name}"
	three:Set[${Return}]
	call getColor "${Actor[ Clicky 4].Name}"
	four:Set[${Return}]
}

function getColor(string actorName)
{
	if ${actorName.Find[Red](exists)}
	{
		return Red
	}
	if ${actorName.Find[Blue](exists)}
	{
		return Blue
	}
	if ${actorName.Find[White](exists)}
	{
		return White
	}
	if ${actorName.Find[Purple](exists)}
	{
		return Purple
	}
	return NA
}